using Microsoft.Xna.Framework;
using Nez;

namespace Inky.Skeletron
{
    public class Skeletron : RenderableComponent, IUpdatable
    {
        public override float Height => 100;
        public override float Width => 100;

        public Shape _body;
        private EdgeAttachment _neckJoint;
        
        public Skeletron()
        {
            _body = new Rectangle(80, 200);
            (_body as Rectangle).Attach(Edge.Left, new Rectangle(30, 10));
            (_body as Rectangle).Attach(Edge.Right, new Rectangle(60, 10));
            (_body as Rectangle).Attach(Edge.Right, new Rectangle(60, 10), 0, 0.3f);
            var head = new Rectangle(80, 80);
            head.Attach(Edge.Top, new Rectangle(100, 5), 0, 0);
            _neckJoint = (_body as Rectangle).Attach(Edge.Top, head, -1, 0);
            (_body as Rectangle).Attach(Edge.Bottom, new Line(40, true), -0.5f, 0);
            (_body as Rectangle).Attach(Edge.Bottom, new Line(40, true), 0.5f, 0);
        }

        public void Update()
        {
            _neckJoint.XOffset += Time.DeltaTime;
        }

        public override void Render(Batcher batcher, Camera camera)
        {
            _body.Draw(batcher, Entity.Position.X, Entity.Position.Y, Color.Black);
        }
    }
}